import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.LinkedList;
import java.util.TreeSet;

public class Hotel {

	public Hotel() {
		this.listeClients = new LinkedList<Client>();
		this.comparaisonPlanningHotel = new ComparePlanningJournalier();
		this.planningGeneral = new TreeSet<PlanningJournalier>(this.comparaisonPlanningHotel);
	}

	public void ajouterClient(Client c) {
		this.listeClients.add(c);
		Collections.sort(this.listeClients, new CompareClients());
	}

	public void reserverChambre(LinkedList<Client> l) {
		PlanningJournalier planningCourant;
		PlanningJournalier planningPreExistant;
		for (Client c : l) {
			planningCourant = new PlanningJournalier(c.dateArrivee);
			this.planningGeneral.add(planningCourant);
			planningPreExistant = this.planningGeneral.floor(planningCourant);
			try {
				planningPreExistant.reserverChambre(c);
			} catch (HotelPlein e) {
				e.printStackTrace();
			}
		}
	}
	
	public void SauverListeClients() throws FileNotFoundException{
		File sauvegardeListeClient = new File("src/saveClient.txt");
		PrintWriter pw = new PrintWriter(sauvegardeListeClient);
		for(Client c : this.listeClients){
			pw.println(c.toString());
		}
		pw.close();
	}
	
	public void chargerListeCliant(String nomFichierTxt) throws IOException{
		File listeClient = new File(nomFichierTxt);
		FileReader fr = new FileReader(listeClient);
		BufferedReader br = new BufferedReader(fr);
		String tampon = br.readLine();
		String[] tableauSplit;
		int[] tableauDate = new int[6];
		Date dateNaissanceTampon;
		Date dateArriveeTampon;
		while(tampon != null){
			tableauSplit = tampon.split(":");
			for(int i = 2; i<tableauSplit.length; i++){
				tableauDate[i-2] = Integer.parseInt(tableauSplit[i]);
			}
			dateNaissanceTampon = new Date(tableauDate[0],tableauDate[1],tableauDate[2]);
			dateArriveeTampon = new Date(tableauDate[3],tableauDate[4],tableauDate[5]);
			this.listeClients.add(new Client(tableauSplit[0],tableauSplit[1],dateNaissanceTampon, dateArriveeTampon));
			tampon = br.readLine();
		}
		br.close();
		fr.close();		
	}

	LinkedList<Client> listeClients;
	TreeSet<PlanningJournalier> planningGeneral;
	ComparePlanningJournalier comparaisonPlanningHotel;

}
