import java.util.Stack;

public class PlanningJournalier {
	
	public PlanningJournalier(Date d){
		this.datePlanning = d;
		this.pileChambresLibres = new Stack<Chambre>();
		for(int i = 0; i < 5; i++){
			this.pileChambresLibres.add(new Chambre(i));
		}
		this.tableauChambresOccupees = new Chambre[5];
	}
	
	public void libererChambre(int n) throws PasDeChambreOccupee{
		Chambre chambreCourante = this.tableauChambresOccupees[n - 1];
		if(chambreCourante != null){
			this.pileChambresLibres.add(chambreCourante);
		}
		else throw new PasDeChambreOccupee("La chambre " + n + " est dj libre.");
	}
	
	public void reserverChambre(Client c) throws HotelPlein{
		if(!this.pileChambresLibres.empty()){
			Chambre chambreAttribuee = this.pileChambresLibres.pop();
			this.tableauChambresOccupees[chambreAttribuee.numero - 1] = chambreAttribuee;
			c.numeroChambre = chambreAttribuee.numero;
		}
		else throw new HotelPlein("Toutes les chambres sont prises.");
	}
	
	public String toString(){
		String s = "";
		for(int i = 0; i<this.tableauChambresOccupees.length -1; i++){
			s += this.tableauChambresOccupees[i] + ", ";
		}
		s += this.tableauChambresOccupees[this.tableauChambresOccupees.length - 1];
		return this.datePlanning + " : " + this.pileChambresLibres + " --- [" + s + "]";
	}
	
	Date datePlanning;
	Stack<Chambre> pileChambresLibres;
	 Chambre[] tableauChambresOccupees;
		
}
